diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 9aa5954b..0f8ae794 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -449,54 +592,109 @@ class SquadService extends Actor {
     }
   }
 
-  def UpdateSquadList(squad : Squad, listingChanged : List[Int]) : Unit = {
-    //queue updates
+  def JoinSquad(player : Player, squad : Squad, line : Int) : Boolean = {
+    val charId = player.CharId
+    val position = squad.Membership(line)
+    if(squad.Availability(line) && position.CharId == 0 &&
+      player.Certifications.intersect(position.Requirements) == position.Requirements) {
+      position.Name = player.Name
+      position.CharId = charId
+      position.Health = StatConverter.Health(player.Health, player.MaxHealth, min=1, max=64)
+      position.Armor = StatConverter.Health(player.Armor, player.MaxArmor, min=1, max=64)
+      position.Position = player.Position
+      position.ZoneId = 13
+      memberToSquad(player.CharId) = squad
+
+      val size = squad.Size
+      if(size == 1) {
+        //leader joins the squad? do nothing?
+        squad.LeaderPositionIndex = line
+      }
+      else if(size == 2) {
+        //first squad member after leader; both members fully initialize
+        val indices = squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+        squad.Membership
+          .collect({ case member if member.CharId != 0 => member.CharId })
+          .foreach { charId =>
+            SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", SquadResponse.Join(squad, indices)))
+          }
+      }
+      else {
+        //joining an active squad; everybody updates differently
+        //new member gets full UI updates
+        sender ! SquadServiceResponse("", SquadResponse.Join(
+          squad,
+          squad.Membership.zipWithIndex.collect({ case (member, index) if member.CharId != 0 => index }).toList
+        ))
+        //other squad members see us joining the squad
+        val updatedIndex = List(line)
+        squad.Membership
+          .collect({ case member if member.CharId != 0 && member.CharId != charId => member.CharId })
+          .foreach { charId =>
+            SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", SquadResponse.Join(squad, updatedIndex)))
+          }
+      }
+      true
+    }
+    else {
+      false
+    }
+  }
+
+  def UpdateSquadList(squad : Squad, changes : SquadInfo) : Unit = {
+    UpdateSquadList(squad, Some(changes))
+  }
+
+  def UpdateSquadListWhenListed(squad : Squad, changes : SquadInfo) : Unit = {
+    UpdateSquadListWhenListed(squad, Some(changes))
+  }
+
+  def UpdateSquadListWhenListed(squad : Squad, changes : Option[SquadInfo]) : Unit = {
     if(squad.Listed) {
-      val entry = SquadService.Publish(squad)
-      val faction = squad.Faction
-      val factionListings = publishedLists(faction)
-      factionListings.find(info => {
-        info.squad_guid match {
-          case Some(sguid) => sguid == squad.GUID
-          case _ => false
-        }
-      }) match {
-        case Some(listedSquad) =>
-          val index = factionListings.indexOf(listedSquad)
-          val changes = if(listingChanged.nonEmpty) {
-            SquadService.Differences(listingChanged, entry)
-          }
-          else {
-            SquadService.Differences(listedSquad, entry)
-          }
-          if(changes != SquadInfo.Blank) {
+      UpdateSquadList(squad, changes)
+    }
+  }
+
+  def UpdateSquadList(squad : Squad, changes : Option[SquadInfo]) : Unit = {
+    val entry = SquadService.SquadList.Publish(squad)
+    val faction = squad.Faction
+    val factionListings = publishedLists(faction)
+    factionListings.find(info => {
+      info.squad_guid match {
+        case Some(sguid) => sguid == squad.GUID
+        case _ => false
+      }
+    }) match {
+      case Some(listedSquad) =>
+        val index = factionListings.indexOf(listedSquad)
+        changes match {
+          case Some(changedFields) =>
             //squad information update
             log.info(s"Squad will be updated")
             factionListings(index) = entry
             SquadEvents.publish(
-              SquadServiceResponse(s"$faction/Squad", SquadResponse.Update(Seq((index, changes))))
+              SquadServiceResponse(s"$faction/Squad", SquadResponse.UpdateList(Seq((index, changedFields))))
             )
-          }
-          else {
+          case None =>
             //remove squad from listing
             log.info(s"Squad will be removed")
             factionListings.remove(index)
             SquadEvents.publish(
-              SquadServiceResponse(s"$faction/Squad", SquadResponse.Remove(Seq(index)))
+              //SquadServiceResponse(s"$faction/Squad", SquadResponse.RemoveFromList(Seq(index)))
+              SquadServiceResponse(s"$faction/Squad", SquadResponse.InitList(factionListings.toVector))
             )
-          }
-        case None =>
-          //first time being published
-          log.info(s"Squad will be introduced")
-          factionListings += SquadService.Publish(squad)
-          SquadEvents.publish(
-            SquadServiceResponse(s"$faction/Squad", SquadResponse.Init(factionListings.toVector))
-          )
-      }
+        }
+      case None =>
+        //first time being published
+        log.info(s"Squad will be introduced")
+        factionListings += entry
+        SquadEvents.publish(
+          SquadServiceResponse(s"$faction/Squad", SquadResponse.InitList(factionListings.toVector))
+        )
     }
   }
 
-  def GenSquadDetail(squad : Squad) : SquadResponse.Detail = {
+  def GenSquadDetail(guid : PlanetSideGUID, squad : Squad) : SquadResponse.Detail = {
     SquadResponse.Detail(
       squad.GUID,
       squad.Leader.Name,
@@ -513,60 +711,164 @@ class SquadService extends Actor {
     )
   }
 
-  def UpdateSquadDetail(squad : Squad) : Unit = {
-    val detail = GenSquadDetail(squad)
-    squad.Membership.collect {
-      case member if !member.Name.equals("") =>
-        member.Name
-    }.foreach { name =>
-      SquadEvents.publish(
-        SquadServiceResponse(s"$name/Squad", detail)
-      )
+  def UpdateListedSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    if(squad.Listed) {
+      UpdateSquadDetail(guid, squad)
     }
   }
+
+  def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
+    val detail = GenSquadDetail(guid, squad)
+    squad.Membership
+      .collect { case member if member.CharId > 0L => member.CharId }
+      .foreach { charId =>
+        SquadEvents.publish(SquadServiceResponse(s"$charId/Squad", detail))
+      }
+  }
 }
 
 object SquadService {
-  def Publish(squad : Squad) : SquadInfo = {
-    SquadInfo(
-      squad.Leader.Name,
-      squad.Task,
-      PlanetSideZoneID(squad.ZoneId),
-      squad.Size,
-      squad.Capacity,
-      squad.GUID
-    )
-  }
+  trait PositionBid
 
-  def Differences(updates : List[Int], info : SquadInfo) : SquadInfo = {
-    if(updates.nonEmpty) {
-      val list = Seq(
-        SquadInfo.Blank, //must be index-0
-        SquadInfo(info.leader, None, None, None, None),
-        SquadInfo(None, info.task, None, None, None),
-        SquadInfo(None, None, info.zone_id, None, None),
-        SquadInfo(None, None, None, info.size, None),
-        SquadInfo(None, None, None, None, info.capacity)
+  final case class NormalBid(char_id : Long, squad_guid : PlanetSideGUID, position : Int) extends PositionBid
+
+  final case class VacancyBid(char_id : Long, squad_guid : PlanetSideGUID) extends PositionBid
+
+  final case class CamraderieBid(char_id : Long, placeholder : Squad) extends PositionBid
+
+  object SquadList {
+    def Publish(squad : Squad) : SquadInfo = {
+      SquadInfo(
+        squad.Leader.Name,
+        squad.Task,
+        PlanetSideZoneID(squad.ZoneId),
+        squad.Size,
+        squad.Capacity,
+        squad.GUID
       )
-      var out = SquadInfo.Blank
-      updates
-        .map(i => list(i))
-        .filterNot { _ == SquadInfo.Blank }
-        .foreach(sinfo => out = out And sinfo )
-      out
-    }
-    else {
-      SquadInfo.Blank
     }
   }
 
-  def Differences(before : SquadInfo, after : SquadInfo) : SquadInfo = {
-    SquadInfo(
-      if(!before.leader.equals(after.leader)) after.leader else None,
-      if(!before.task.equals(after.task)) after.task else None,
-      if(!before.zone_id.equals(after.zone_id)) after.zone_id else None,
-      if(!before.size.equals(after.size)) after.size else None,
-      if(!before.capacity.equals(after.capacity)) after.capacity else None
-    )
+  object Detail {
+    def Publish(squad : Squad) : SquadDetail = {
+      SquadDetail()
+        .LeaderCharId(squad.Leader.CharId)
+        .LeaderName(squad.Leader.Name)
+        .Task(squad.Task)
+        .ZoneId(PlanetSideZoneID(squad.ZoneId))
+        .Members(
+          squad.Membership.zipWithIndex.map({ case (p, index) =>
+            SquadPositionEntry(index, if(squad.Availability(index)) {
+              SquadPositionDetail(p.Role, p.Orders, p.Requirements, p.CharId, p.Name)
+            }
+            else {
+              SquadPositionDetail.Closed
+            })
+          }).toList
+        )
+        .Complete
+    }
+
+    def Differences(updates : List[Int], info : SquadDetail) : SquadDetail = {
+      if(updates.nonEmpty) {
+        val list = Seq(
+          SquadDetail.Blank, //must be index-0
+          SquadDetail(info.unk1, None, None, None, None, None, None, None, None),
+          SquadDetail(None, None, info.leader_char_id, None, None, None, None, None, None),
+          SquadDetail(None, None, None, info.unk3, None, None, None, None, None),
+          SquadDetail(None, None, None, None, info.leader_name, None, None, None, None),
+          SquadDetail(None, None, None, None, None, info.task, None, None, None),
+          SquadDetail(None, None, None, None, None, None, info.zone_id, None, None),
+          SquadDetail(None, None, None, None, None, None, None, info.unk7, None),
+          SquadDetail(None, None, None, None, None, None, None, None, info.member_info)
+        )
+        var out = SquadDetail.Blank
+        updates
+          .map(i => list(i))
+          .filterNot { _ == SquadDetail.Blank }
+          .foreach(sinfo => out = out And sinfo )
+        out
+      }
+      else {
+        SquadDetail.Blank
+      }
+    }
+
+    def Differences(before : SquadDetail, after : SquadDetail) : SquadDetail = {
+      SquadDetail(
+        if(!before.unk1.equals(after.unk1)) after.unk1 else None,
+        None,
+        if(!before.leader_char_id.equals(after.leader_char_id)) after.leader_char_id else None,
+        if(!before.unk3.equals(after.unk3)) after.unk3 else None,
+        if(!before.leader_name.equals(after.leader_name)) after.leader_name else None,
+        if(!before.task.equals(after.task)) after.task else None,
+        if(!before.zone_id.equals(after.zone_id)) after.zone_id else None,
+        if(!before.unk7.equals(after.unk7)) after.unk7 else None,
+        {
+          (before.member_info, after.member_info) match {
+            case (Some(beforeEntry), Some(afterEntry)) =>
+              val out = beforeEntry.zip(afterEntry)
+                .map { case (b, a) => PositionEquality(b, a) }
+                .collect { case Some(entry) => entry }
+              if(out.nonEmpty) {
+                Some(out)
+              }
+              else {
+                None
+              }
+            case _ =>
+              None
+          }
+        }
+      )
+    }
+
+    private def PositionEquality(before : SquadPositionEntry, after : SquadPositionEntry) : Option[SquadPositionEntry] = {
+      (before.info, after.info) match {
+        case (Some(binfo), Some(ainfo)) =>
+          val out = MemberEquality(binfo, ainfo)
+          if(out == SquadPositionDetail.Blank) {
+            None
+          }
+          else {
+            Some(SquadPositionEntry(before.index, out))
+          }
+        case _ =>
+          None
+      }
+    }
+
+    private def MemberEquality(before : SquadPositionDetail, after : SquadPositionDetail) : SquadPositionDetail = {
+      SquadPositionDetail(
+        if(!before.is_closed.equals(after.is_closed)) after.is_closed else None,
+        if(!before.role.equals(after.role)) after.role else None,
+        if(!before.detailed_orders.equals(after.detailed_orders)) after.detailed_orders else None,
+        if(!before.requirements.equals(after.requirements)) after.requirements else None,
+        if(!before.char_id.equals(after.char_id)) after.char_id else None,
+        if(!before.name.equals(after.name)) after.name else None
+      )
+    }
+  }
+
+  def LoadSquadDefinition(squad : Squad, favorite : SquadLoadout) : Unit = {
+    squad.Task = favorite.task
+    squad.ZoneId = favorite.zone_id.getOrElse(squad.ZoneId)
+    squad.Availability.indices.foreach { index => squad.Availability.update(index, false) }
+    squad.Membership.foreach { position =>
+      position.Role = ""
+      position.Orders = ""
+      position.Requirements = Set()
+    }
+    favorite.members.foreach { position =>
+      squad.Availability.update(position.index, true)
+      val member = squad.Membership(position.index)
+      member.Role = position.role
+      member.Orders = position.orders
+      member.Requirements = position.requirements
+    }
+  }
+
+  def ValidOpenSquadPosition(squad : Squad, position : Int, member : Member, reqs : Set[CertificationType.Value]) : Boolean = {
+    squad.Availability(position) && member.CharId == 0 && reqs.intersect(member.Requirements) == member.Requirements
   }
 }
diff --git a/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala b/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
index f36b61c5..09e2cd42 100644
--- a/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
+++ b/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
@@ -54,7 +54,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 3
-        action mustEqual SaveSquadDefinition()
+        action mustEqual SaveSquadFavorite()
       case _ =>
         ko
     }
@@ -65,7 +65,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 3
-        action mustEqual LoadSquadDefinition()
+        action mustEqual LoadSquadFavorite()
       case _ =>
         ko
     }
@@ -76,7 +76,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 3
-        action mustEqual ListSquadDefinition("Cops and Military Officers")
+        action mustEqual ListSquadFavorite("Cops and Military Officers")
       case _ =>
         ko
     }
@@ -87,7 +87,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual ListSquad()
+        action mustEqual RequestListSquad()
       case _ =>
         ko
     }
@@ -328,28 +328,28 @@ class SquadDefinitionActionMessageTest extends Specification {
   }
 
   "encode (03)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, SaveSquadDefinition())
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, SaveSquadFavorite())
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_03
   }
 
   "encode (03)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, LoadSquadDefinition())
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, LoadSquadFavorite())
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_04
   }
 
   "encode (07)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, ListSquadDefinition("Cops and Military Officers"))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 3, ListSquadFavorite("Cops and Military Officers"))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_07
   }
 
   "encode (08)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, ListSquad())
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, RequestListSquad())
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_08
diff --git a/pslogin/src/main/scala/WorldSessionActor.scala b/pslogin/src/main/scala/WorldSessionActor.scala
index 6064e729..37619aec 100644
--- a/pslogin/src/main/scala/WorldSessionActor.scala
+++ b/pslogin/src/main/scala/WorldSessionActor.scala
@@ -346,10 +346,13 @@ class WorldSessionActor extends Actor with MDCContextAware {
 
     case SquadServiceResponse(toChannel, response) =>
       response match {
-        case SquadResponse.Init(infos) if infos.nonEmpty =>
+        case SquadResponse.ListSquadFavorite(line, task) =>
+          sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), line, SquadAction.ListSquadFavorite(task)))
+
+        case SquadResponse.InitList(infos) if infos.nonEmpty =>
           sendResponse(ReplicationStreamMessage(infos))
 
-        case SquadResponse.Update(infos) if infos.nonEmpty =>
+        case SquadResponse.UpdateList(infos) if infos.nonEmpty =>
           val o = ReplicationStreamMessage(6, None,
             infos.map { case (index, squadInfo) =>
               SquadListing(index, squadInfo)
@@ -364,7 +367,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
             )
           )
 
-        case SquadResponse.Remove(infos) if infos.nonEmpty =>
+        case SquadResponse.RemoveFromList(infos) if infos.nonEmpty =>
           sendResponse(
             ReplicationStreamMessage(1, None,
               infos.map { index =>
@@ -387,9 +390,21 @@ class WorldSessionActor extends Actor with MDCContextAware {
             )
           )
 
+        case SquadResponse.InitSquad(squad_guid) =>
+          sendResponse(SquadDefinitionActionMessage(squad_guid, 0, SquadAction.Unknown(16)))
+          sendResponse(SquadDefinitionActionMessage(squad_guid, 0, SquadAction.SetListSquad()))
+
+        case SquadResponse.Unknown17(squad, char_id) =>
+          sendResponse(
+            SquadDefinitionActionMessage(squad.GUID, 0, SquadAction.Unknown(33))
+          )
+
         case SquadResponse.Membership(request_type, unk1, unk2, unk3, unk4, player_name, unk5, unk6) =>
           sendResponse(SquadMembershipResponse(request_type, unk1, unk2, unk3, unk4, player_name, unk5, unk6))
 
+        case SquadResponse.Invite(from_char_id, to_char_id, name) =>
+          sendResponse(SquadMembershipResponse(SquadResponseType.Invite, 0, 0, from_char_id, Some(to_char_id), s"$name", false, Some(None)))
+
         case SquadResponse.Join(squad, positionsToUpdate) =>
           val leader = squad.Leader
           val id = 11
@@ -399,7 +414,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
           membershipPositions.find({ case(member, _) => member.CharId == avatar.CharId }) match {
             case Some((ourMember, ourIndex)) =>
               //we are joining the squad
-              sendResponse(SquadMembershipResponse(SquadRequestType.Accept, 0, 0, player.CharId, Some(leader.CharId), player.Name, true, Some(None)))
+              sendResponse(SquadMembershipResponse(SquadResponseType.Accept, 0, 0, player.CharId, Some(leader.CharId), player.Name, true, Some(None)))
               //load each member's entry (our own too)
               membershipPositions.foreach { case(member, index) =>
                 sendResponse(SquadMemberEvent(0, id, member.CharId, index, Some(member.Name), Some(member.ZoneId), Some(0)))
@@ -410,7 +425,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
               sendResponse(PlanetsideAttributeMessage(player.GUID, 31, id)) //associate with squad?
               sendResponse(PlanetsideAttributeMessage(player.GUID, 32, ourIndex)) //associate with member position in squad?
               //a finalization? what does this do?
-              sendResponse(SquadDefinitionActionMessage(squad.GUID, 0, SquadAction.Unknown(18, hex"00".toBitVector.take(6))))
+              sendResponse(SquadDefinitionActionMessage(squad.GUID, 0, SquadAction.Unknown(18)))
             case _ =>
               //other player is joining our squad
               //load each member's entry
@@ -432,7 +447,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
           positionsToUpdate.find({ case(member, _) => member == avatar.CharId }) match {
             case Some((ourMember, ourIndex)) =>
               //we are leaving the squad
-              sendResponse(SquadMembershipResponse(SquadRequestType.Leave, 0,1, avatar.CharId, Some(avatar.CharId), avatar.name, true, Some(None)))
+              sendResponse(SquadMembershipResponse(SquadResponseType.Leave, 0,1, avatar.CharId, Some(avatar.CharId), avatar.name, true, Some(None)))
               //remove each member's entry (our own too)
               positionsToUpdate.foreach { case(member, index) =>
                 sendResponse(SquadMemberEvent(1, id, member, index, None, None, None))
@@ -444,7 +459,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
               sendResponse(PlanetsideAttributeMessage(player.GUID, 32, 0)) //disassociate with member position in squad?
               sendResponse(PlanetsideAttributeMessage(player.GUID, 34, 4294967295L)) //unknown, perhaps unrelated?
               //a finalization? what does this do?
-              sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SquadAction.Unknown(18, hex"00".toBitVector.take(6))))
+              sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SquadAction.Unknown(18)))
             case _ =>
               //remove each member's entry
               positionsToUpdate.foreach { case(member, index) =>
@@ -455,6 +470,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
 
         case SquadResponse.UpdateMembers(squad, positions) =>
           import services.teamwork.SquadAction.{Update => SAUpdate}
+          val id = 11
           val pairedEntries = positions.collect {
             case entry if squadUI.contains(entry.char_id) =>
               (entry, squadUI(entry.char_id))
@@ -476,12 +492,31 @@ class WorldSessionActor extends Actor with MDCContextAware {
           if(updatedEntries.nonEmpty) {
             sendResponse(
               SquadState(
-                PlanetSideGUID(11),
+                PlanetSideGUID(id),
                 updatedEntries.map { entry => SquadStateInfo(entry.char_id, entry.health, entry.armor, entry.pos, 2,2, false, 429, None,None)}
               )
             )
           }
 
+        case SquadResponse.SwapMember(squad, to_index, from_index) =>
+          //this failsafe is not supported by normal squad member operations
+          val member = squad.Membership(to_index)
+          val charId = member.CharId
+          val elem = squadUI(charId)
+          val id = 11
+          squadUI(charId) = SquadUIElement(elem.name, to_index, elem.zone, elem.health, elem.armor, elem.position)
+          sendResponse(SquadMemberEvent(1, id, charId, from_index, None, None, None))
+          sendResponse(SquadMemberEvent(0, id, charId, to_index, Some(elem.name), Some(elem.zone), Some(0)))
+          sendResponse(
+            SquadState(
+              PlanetSideGUID(id),
+              List(SquadStateInfo(charId, elem.health, elem.armor, elem.position, 2,2, false, 429, None,None))
+            )
+          )
+          if(charId == avatar.CharId) {
+            sendResponse(PlanetsideAttributeMessage(player.GUID, 32, to_index))
+          }
+
         case _ => ;
       }
 
@@ -956,7 +991,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
       galaxyService ! Service.Join("galaxy") //for galaxy-wide messages
       galaxyService ! Service.Join(s"${avatar.faction}") //for hotspots
       squadService ! Service.Join(s"${avatar.faction}") //channel will be player.Faction
-      squadService ! Service.Join(avatar.name) //management of any lingering squad information connected to this player
+      squadService ! Service.Join(s"${avatar.CharId}") //channel will be player.CharId (in order to work with packets)
       cluster ! InterstellarCluster.GetWorld("home3")
 
     case InterstellarCluster.GiveWorld(zoneId, zone) =>
@@ -2964,14 +2999,14 @@ class WorldSessionActor extends Actor with MDCContextAware {
     //AvatarAwardMessage
     //DisplayAwardMessage
     sendResponse(PlanetsideStringAttributeMessage(guid, 0, "Outfit Name"))
-    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SquadAction.Unknown(6, hex"".toBitVector)))
+    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SquadAction.Unknown(6)))
     (0 to 9).foreach(line => {
-      sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), line, SquadAction.ListSquadDefinition("")))
+      sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), line, SquadAction.ListSquadFavorite("")))
     })
     sendResponse(SquadDetailDefinitionUpdateMessage.Init)
-    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(16, hex"".toBitVector)))
-    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(17, hex"".toBitVector)))
-    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(18, hex"".toBitVector)))
+    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(16)))
+    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.SetListSquad()))
+    sendResponse(SquadDefinitionActionMessage(PlanetSideGUID(0), 0,SquadAction.Unknown(18)))
     //MapObjectStateBlockMessage and ObjectCreateMessage?
     //TacticsMessage?
     //change the owner on our deployables (re-draw the icons for our deployables too)
@@ -3419,7 +3454,7 @@ class WorldSessionActor extends Actor with MDCContextAware {
     case msg @ PlayerStateMessageUpstream(avatar_guid, pos, vel, yaw, pitch, yaw_upper, seq_time, unk3, is_crouching, is_jumping, unk4, is_cloaking, unk5, unk6) =>
       if(deadState == DeadState.Alive) {
         if(!player.Crouching && is_crouching) { //SQUAD TESTING CODE
-          sendResponse(SquadMemberEvent(3, 11, 353380L, 3, None, Some(13), None))
+          sendResponse(SquadMembershipResponse(SquadResponseType.Unk01, 0, 0, player.CharId, None, "Dummy", false, Some(None)))
         }
         player.Position = pos
         player.Velocity = vel

